
#version 430

#ifdef VERTEX_SHADER

in vec3 in_position;
in vec3 in_normal;

uniform mat4 model;

#include "shaders/lib/camera.glsl"

out vec3 normal;
out vec2 texcoord;

void main() {
    vec4 model_position = vec4(in_position, 1.0f);
    gl_Position = viewProjection * (model * model_position);

    // @BUG: this is technically only correct for orthonormal model matrices!
    vec3 worldNormal = normalize((model * vec4(in_normal, 0.0)).xyz);
    normal = (view * vec4(worldNormal, 0.0)).xyz;
}

#endif

#ifdef FRAGMENT_SHADER

in vec3 normal;

out vec4 fragColor;
out vec3 fragNormal;

uniform vec4 diffuseColor;

void main() {
    fragColor = diffuseColor;
    fragNormal = normal;
}

#endif

