#version 150

#ifdef VERTEX_SHADER

in vec3 in_position;
in vec2 in_texcoord;

out vec2 texcoord;

void main() {
    gl_Position = vec4(in_position.xz * 2 - 1, 0.0, 1.0);
    texcoord = in_texcoord;
}

#endif

#ifdef FRAGMENT_SHADER

in vec2 texcoord;

out vec4 fragColor;

uniform sampler2D in_texture0;
uniform sampler2D in_texture1;
uniform sampler2D in_texture2;
uniform sampler2D in_texture3;

uniform sampler2D in_blendMap;

uniform float GameTime;

void main() {
    //vec4 blendWeights = texture(in_blendMap, texcoord);
    vec4 blendWeights = normalize(
                                  vec4(6, 12, 12, max(0, 2 + 4 * sin(GameTime)))
                                  );
        
    vec4 sample0 = texture(in_texture0, texcoord);
    vec4 sample1 = texture(in_texture1, texcoord);
    vec4 sample2 = texture(in_texture2, texcoord);
    vec4 sample3 = texture(in_texture3, texcoord);
      
    fragColor = (blendWeights[0] * sample0 +
                 blendWeights[1] * sample1 +
                 blendWeights[2] * sample2 +
                 blendWeights[3] * sample3);

    //fragColor = blendWeights;
}

#endif
