#version 150

#ifdef VERTEX_SHADER

in vec3 in_position;
in vec2 in_texcoord;

out vec2 vs_chromaValue;

uniform mat4 model;
uniform mat4 viewProjection;

void main() {
    gl_Position = viewProjection * (model * vec4(in_position.xy, 0, 1));
    vs_chromaValue = in_texcoord;
}

#endif

#ifdef FRAGMENT_SHADER

#include "shaders/lib/color.glsl"

in vec2 vs_chromaValue;
out vec4 fragColor;

uniform float hue;

void main() {
    float saturation = 0;
    if (vs_chromaValue.y > 0.0) {
        saturation = vs_chromaValue.x / vs_chromaValue.y;
    }
    vec3 hsv = vec3(hue, saturation, vs_chromaValue.y);
    vec3 rgb = HSVToRGB(hsv);
    rgb = RYBToRGB(rgb);
    fragColor = vec4(rgb, 1);
}

#endif

