
#if !ETC_RELEASE
#if ETC_DEBUG
EtcDebugMemory *DebugMem = NULL;
void RegisterDebugMemory(EtcDebugMemory *debugMem) {
    DebugMem = debugMem;
}

EtcDebugMemory *GetDebugMemory() {
    return DebugMem;
}
#endif
#endif


void InitDebug(EtcDebugMemory *debugMem) {
    AllocateMemoryArena(&debugMem->arena, DEBUG_ARENA_SIZE);

    // Quad
    {
        Mesh mesh = {};
        AllocatePlane(&mesh, 2);
        debugMem->quad = LoadProceduralMesh(Game.assets, "quad", &mesh);
    }

    {
        Mesh mesh = {};
        AllocatePlane(&mesh, 2);
        debugMem->quad = LoadProceduralMesh(Game.assets, "quad", &mesh);
    }

    // Cube
    {
        Mesh mesh = {};
        AllocateCube(&mesh);
        debugMem->cube = LoadProceduralMesh(Game.assets, "cube", &mesh);
    }

    // Skybox Cube
    {
        Mesh mesh = {};
        AllocateSkyboxCube(&mesh);
        debugMem->skyboxCube = LoadProceduralMesh(Game.assets, "skyboxCube", &mesh);
    }

    // Sphere
    {
        Mesh mesh = {};
        AllocateSphere(&mesh, 1);
        debugMem->sphere = LoadProceduralMesh(Game.assets, "sphere", &mesh);
    }

    // Sphere
    {
        Mesh mesh = {};
        AllocateSphere(&mesh, 3);
        debugMem->sphereHiPoly = LoadProceduralMesh(Game.assets, "sphereHiPoly", &mesh);
    }

    // Cylinder
    {
        Mesh mesh = {};
        AllocateCylinder(&mesh, 16);
        debugMem->cylinder = LoadProceduralMesh(Game.assets, "cylinder", &mesh);
    }


    // Octagon
    {
        Mesh mesh = {};
        AllocateCylinder(&mesh, 8);
        debugMem->octagon = LoadProceduralMesh(Game.assets, "octagon", &mesh);
    }

    // Trigon
    {
        Mesh mesh = {};
        AllocateCylinder(&mesh, 3);
        debugMem->trigon = LoadProceduralMesh(Game.assets, "trigon", &mesh);
    }


    // Hexagon
    {
        Mesh mesh = {};
        AllocateCylinder(&mesh, 6);
        debugMem->hexagon = LoadProceduralMesh(Game.assets, "hexagon", &mesh);
    }


    // Pentagon
    {
        Mesh mesh = {};
        AllocateCylinder(&mesh, 5);
        debugMem->pentagon = LoadProceduralMesh(Game.assets, "pentagon", &mesh);
    }

    // Diamond
    {
        Mesh mesh = {};
        AllocateCylinder(&mesh, 4);
        debugMem->diamond = LoadProceduralMesh(Game.assets, "diamond", &mesh);
    }

    // Arrow
    {
        Mesh mesh = {};
        AllocateArrow(&mesh);
        debugMem->arrow = LoadProceduralMesh(Game.assets, "arrow", &mesh);
    }

    // Cone
    {
        Mesh mesh = {};
        AllocateCone(&mesh, 1.0f, 0.5f, 24);
        debugMem->cone = LoadProceduralMesh(Game.assets, "cone", &mesh);
    }

    {
        Mesh mesh = {};
        AllocateCone(&mesh, 1.0f, 1.0f, 16);
        debugMem->spotlightCone = LoadProceduralMesh(Game.assets, "spotlightCone", &mesh);
    }

    // Circle
    {
        Mesh mesh = {};
        AllocateCircle(&mesh, 1.0f, 16);
        debugMem->circle = LoadProceduralMesh(Game.assets, "circle", &mesh);
    }


    // Debug Textures
    {
        Texture white;
        AllocateTexture(&white, 1, 1, TextureFormat_RGBA8);
        ((RGBA8 *)white.data.u8)[0] = WHITE8;
        debugMem->white = LoadProceduralTexture(Game.assets, "white", &white);

        Texture black;
        AllocateTexture(&black, 1, 1, TextureFormat_RGBA8);
        ((RGBA8 *)black.data.u8)[0] = BLACK8;
        debugMem->black = LoadProceduralTexture(Game.assets, "black", &black);

        Texture magenta;
        AllocateTexture(&magenta, 1, 1, TextureFormat_RGBA8);
        ((RGBA8 *)magenta.data.u8)[0] = MAGENTA8;
        debugMem->magenta = LoadProceduralTexture(Game.assets, "magenta", &magenta);

        Texture clear;
        AllocateTexture(&clear, 1, 1, TextureFormat_RGBA8);
        ((RGBA8 *)clear.data.u8)[0] = CLEAR8;
        debugMem->clear = LoadProceduralTexture(Game.assets, "clear", &clear);
    }

    {
        Material missingMaterial = {};
        missingMaterial.diffuseColor = MAGENTA;
        missingMaterial.diffuseMap = debugMem->magenta;

        debugMem->missingMaterial = missingMaterial;
    }

    debugMem->passthroughShader = LoadShaderProgram(Game.assets, "passthrough");
    debugMem->passthroughDepthShader = LoadShaderProgram(Game.assets, "passthroughDepth");
    debugMem->passthroughNormalShader = LoadShaderProgram(Game.assets, "passthroughNormal");

    debugMem->passthroughBlendedShader = LoadShaderProgram(Game.assets, "passthroughBlended");
    debugMem->passthroughNormalBlendedShader = LoadShaderProgram(Game.assets, "passthroughNormalBlended");

    debugMem->debugPaintedSkyboxShader = LoadShaderProgram(Game.assets, "debugPaintedSkyboxShader");

    debugMem->debugFontHandle = LoadFontTable(Game.assets, "courier_becker_bold");

    debugMem->debugUIArrowRight = LoadTexture(Game.assets, "ui_arrow_right");
    debugMem->debugUIArrowDown = LoadTexture(Game.assets, "ui_arrow_down");
    debugMem->debugUIArrowLeft = LoadTexture(Game.assets, "ui_arrow_left");
    debugMem->debugUIArrowUp = LoadTexture(Game.assets, "ui_arrow_up");

    {
        Mesh mesh = {};
        AllocateColorPickerRing(&mesh);
        debugMem->debugUIColorPickerRing = LoadProceduralMesh(Game.assets, "uiColorPickerRing", &mesh);
    }

    {
        Mesh mesh = {};
        AllocateColorPickerTriangle(&mesh);
        debugMem->debugUIColorPickerTriangle = LoadProceduralMesh(Game.assets, "uiColorPickerTriangle", &mesh);
    }

    debugMem->debugUIColorPickerRingShaderRGB = LoadShaderProgram(Game.assets, "uiColorPickerRingRGB");
    debugMem->debugUIColorPickerRingShaderRYB = LoadShaderProgram(Game.assets, "uiColorPickerRingRYB");
    debugMem->debugUIColorPickerTriangleShaderRGB = LoadShaderProgram(Game.assets, "uiColorPickerTriangleRGB");
    debugMem->debugUIColorPickerTriangleShaderRYB = LoadShaderProgram(Game.assets, "uiColorPickerTriangleRYB");

    
    AllocateCommandList(&debugMem->debugDrawPass, 32768, Kilobytes(1024));
    
    InitDebugDraw(debugMem);

    debugMem->inputCharactersCapacity = DEBUG_MAX_INPUTCHARACTERS + 1;
    debugMem->inputCharacters = ALLOCATE_ARRAY(char, debugMem->inputCharactersCapacity);
    Plat.ClearMem(debugMem->inputCharacters, sizeof(char) * debugMem->inputCharactersCapacity);

    debugMem->scriptInputCharactersCapacity = DEBUG_MAX_INPUTCHARACTERS + 1;
    debugMem->scriptInputCharacters = ALLOCATE_ARRAY(char, debugMem->scriptInputCharactersCapacity);
    Plat.ClearMem(debugMem->scriptInputCharacters, sizeof(char) * debugMem->scriptInputCharactersCapacity);
    debugMem->scriptInputCharactersCount = 0;


    Plat.ClearMem(debugMem->debugRecords, DEBUG_RECORD_COUNT);
    debugMem->debugRecordLabels = MakeDynamicArray<const char *>(32);

    // Initialize Log
    debugMem->log.state = DebugLogState_Hidden;
    debugMem->log.displayState = DebugLogDisplayState_Scrolling;
    AllocateBufferedList(&DebugMem->log.logData, Kilobytes(512));
    debugMem->log.snapToBottom = false;
}

void DeinitDebug(EtcDebugMemory *debugMem) {
    DeinitDebugDraw(debugMem);
    // TODO: ...
}


// @TODO: this can probably go when Dropdown() function gets another pass
vec2 GetDebugGlyphDimensions(real32 size) {
    real32 pixelSize = size;
    FontTable *font = DebugMem->debugFont;
    real32 advance = font->glyphs[0].advance * pixelSize;
    real32 lineHeight = font->lineHeight * pixelSize;

    return V2(advance, lineHeight);
}


// Debug Log
void RenderDebugLog(EtcGameMemory *mem, DebugLog *log) {
    if (log->state == DebugLogState_Hidden) {
        return;
    }

    UIManager *manager = GetCurrentUIManager();

    
    UIStyle styles[] = {
        MakeStyle4(UIStyle_WindowBackgroundColor, WithAlpha(PASTEL_BLUE, 0.5f)),
        MakeStyleFont(UIStyle_Font, DebugMem->debugFontHandle),
        MakeStylef(UIStyle_FontSize, 14),
        MakeStyle4(UIStyle_FontColor, WHITE),

        MakeStylePadding(UIStyle_Padding, {4, 4, 1, 1}),
    };
    PushStyles(styles, ARRAY_LENGTH(UIStyle, styles));


    if (log->windowRect.pos == V2(0) && log->windowRect.size == V2(0)) {
        int32 padding = 8;
        int32 logWidth = mem->graphics.width / 3;
        int32 logHeight = mem->graphics.height / 2;

        log->windowRect.pos = V2(10, logHeight - padding);
        log->windowRect.size = V2(logWidth, logHeight);
    }

    PushWindow("Log", &log->windowRect.pos, &log->windowRect.size, UIWindowFlag_Freemove | UIWindowFlag_Freescale |UIWindowFlag_ShowTitle);

    PushScrollGroup("LogScroll");

    WidgetGroup *group = PeekWidgetGroup(manager);
        
    BufferedListNode *curr = log->logData.tail;
    uint32 currFrame = 0;

    // @PERF: only do as many of these as we can fit on the window
    while (curr != NULL) {
        LogData *data = ((LogData *)curr->data);
        if (data->frame != currFrame) {
            currFrame = data->frame;
            
            PushTextf("FRAME: %d", data->frame);
        }
        
        EtcRect widgetBounds = GetNextWidgetBounds(manager, group);
        widgetBounds.pos.x += 40;
        SetNextWidgetBounds(manager, group, widgetBounds);
            
        PushText(data->buffer);
        curr = curr->prev;
    }

    PopScrollGroup();
    PopWindow();
    PopStyles();
}


// Debug Draw
void InitDebugDrawLineBuffer(DebugDrawLineBuffer *buffer) {
    buffer->next = NULL;

    buffer->capacity = 8192 * 2;
    buffer->count = 0;
    buffer->bufferSize = sizeof(DebugDrawLineVertex) * buffer->capacity;
    buffer->buffer = (DebugDrawLineVertex *)Plat.AllocateMem(buffer->bufferSize);

    glGenBuffers(1, &buffer->bufferID);
    glBindBuffer(GL_ARRAY_BUFFER, buffer->bufferID);
    glBufferData(GL_ARRAY_BUFFER, buffer->bufferSize, buffer->buffer, GL_STREAM_DRAW);
}

void InitDebugDrawMeshInstanceBuffer(DebugDrawMeshInstanceBuffer *buffer) {
    buffer->next = NULL;

    buffer->capacity = 256;
    buffer->count = 0;

    buffer->bufferSize = sizeof(DebugDrawMeshInstanceData) * buffer->capacity;
    buffer->buffer = (DebugDrawMeshInstanceData *)Plat.AllocateMem(buffer->bufferSize);
    Plat.ClearMem(buffer->buffer, buffer->bufferSize);

    glGenBuffers(1, &buffer->bufferID);
    glBindBuffer(GL_ARRAY_BUFFER, buffer->bufferID);
    glBufferData(GL_ARRAY_BUFFER, buffer->bufferSize, buffer->buffer, GL_STREAM_DRAW);
}

void InitDebugDrawTextInstanceBuffer(DebugDrawTextInstanceBuffer *buffer) {
    buffer->next = NULL;

    buffer->capacity = 256;
    buffer->count = 0;

    buffer->bufferSize = sizeof(DebugDrawTextInstanceData) * buffer->capacity;
    buffer->buffer = (DebugDrawTextInstanceData *)Plat.AllocateMem(buffer->bufferSize);
    Plat.ClearMem(buffer->buffer, buffer->bufferSize);

    glGenBuffers(1, &buffer->bufferID);
    glBindBuffer(GL_ARRAY_BUFFER, buffer->bufferID);
    glBufferData(GL_ARRAY_BUFFER, buffer->bufferSize, buffer->buffer, GL_STREAM_DRAW);
}

void InitDebugDraw(EtcDebugMemory *debugMem) {
    DebugDraw *debugDraw = &debugMem->debugDraw;

    debugDraw->lineShader = LoadShaderProgram(Game.assets, "drawLine");
    debugDraw->meshShader = LoadShaderProgram(Game.assets, "drawMesh");
    debugDraw->textShader = LoadShaderProgram(Game.assets, "drawText");    

    // Line Buffer
    debugDraw->lineBufferHead = (DebugDrawLineBuffer *)Plat.AllocateMem(sizeof(DebugDrawLineBuffer));
    InitDebugDrawLineBuffer(debugDraw->lineBufferHead);
    debugDraw->currentLineBuffer = debugDraw->lineBufferHead;

    debugDraw->screenLineBufferHead = (DebugDrawLineBuffer *)Plat.AllocateMem(sizeof(DebugDrawLineBuffer));
    InitDebugDrawLineBuffer(debugDraw->screenLineBufferHead);
    debugDraw->currentScreenLineBuffer = debugDraw->screenLineBufferHead;

    // Mesh Instance Buffer
    debugDraw->meshInstanceBufferHead = (DebugDrawMeshInstanceBuffer *)Plat.AllocateMem(sizeof(DebugDrawMeshInstanceBuffer));
    InitDebugDrawMeshInstanceBuffer(debugDraw->meshInstanceBufferHead);

    debugDraw->screenMeshInstanceBufferHead = (DebugDrawMeshInstanceBuffer *)Plat.AllocateMem(sizeof(DebugDrawMeshInstanceBuffer));
    InitDebugDrawMeshInstanceBuffer(debugDraw->screenMeshInstanceBufferHead);

    // Text Instance Buffer
    debugDraw->textInstanceBufferHead = (DebugDrawTextInstanceBuffer *)Plat.AllocateMem(sizeof(DebugDrawTextInstanceBuffer));
    InitDebugDrawTextInstanceBuffer(debugDraw->textInstanceBufferHead);

    debugDraw->screenTextInstanceBufferHead = (DebugDrawTextInstanceBuffer *)Plat.AllocateMem(sizeof(DebugDrawTextInstanceBuffer));
    InitDebugDrawTextInstanceBuffer(debugDraw->screenTextInstanceBufferHead);
}

void DeinitDebugDraw(EtcDebugMemory *debugMem) {
}

void RenderDebugDraw() {
    TIMED_BLOCK();
    DebugDraw *debugDraw = &DebugMem->debugDraw;

    CommandList *debugUIPass = &DebugMem->debugDrawPass;

    uint32 lineKey = 0;
    uint32 screenLineKey = 2;
    uint32 meshKey = 1;
    uint32 textKey = 3;

    b32 shouldClearDebugDrawBuffers = !Game.mem->paused || Game.mem->steppingFrame;

    // @TODO: multi-scene debug drawing
    CameraUniformBuffer *cameraUniformBuffer = &GetScene(Game.sceneManager->active.scenes[0])->cameraUniformBuffer;

    // Lines
    ShaderProgram *lineProgram = GetShaderProgram(Game.assets, debugDraw->lineShader);

    if (lineProgram != NULL) {
        DisableDepthTest(debugUIPass, lineKey);
        DisableDepthWrite(debugUIPass, lineKey);
        EnableBlending(debugUIPass, lineKey, GL_FUNC_ADD, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

        SetShader(debugUIPass, lineKey, lineProgram->programID);
        SetUniform(debugUIPass, lineKey, UniformLocation(lineProgram, "viewProjection"), cameraUniformBuffer->viewProjection);

        SetUniform(debugUIPass, lineKey, UniformLocation(lineProgram, "in_depth"), 0, Game.graphics->gbufferTargets[0].depthTarget, GL_TEXTURE_2D);
        SetSampler(debugUIPass, lineKey, 0, Game.graphics->nearestClampEdge);

        DebugDrawLineBuffer *buffer = debugDraw->lineBufferHead;
        while (buffer != NULL && buffer->count > 0) {
            BindBuffer(debugUIPass, lineKey, GL_ARRAY_BUFFER, buffer->bufferID);

            CopyBufferData(debugUIPass, lineKey, GL_ARRAY_BUFFER,
                           buffer->bufferSize, buffer->buffer, GL_STREAM_DRAW);

            EnableVertexAttribute(debugUIPass, lineKey,
                                  Position_Attrib, 3, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawLineVertex),
                                  FIELD_OFFSET(DebugDrawLineVertex, position));

            EnableVertexAttribute(debugUIPass, lineKey,
                                  Color_Attrib, 4, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawLineVertex),
                                  FIELD_OFFSET(DebugDrawLineVertex, color));

            EnableVertexAttribute(debugUIPass, lineKey,
                                  DashParam_Attrib, 1, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawLineVertex),
                                  FIELD_OFFSET(DebugDrawLineVertex, dashParam));

            EnableVertexAttribute(debugUIPass, lineKey,
                                  DepthFailScale_Attrib, 1, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawLineVertex),
                                  FIELD_OFFSET(DebugDrawLineVertex, depthFailScale));
            
            DrawArrays(debugUIPass, lineKey, PrimitiveType_Lines, 0, buffer->count);

            DisableVertexAttribute(debugUIPass, lineKey, Position_Attrib);
            DisableVertexAttribute(debugUIPass, lineKey, Color_Attrib);
            DisableVertexAttribute(debugUIPass, lineKey, DashParam_Attrib);
            DisableVertexAttribute(debugUIPass, lineKey, DepthFailScale_Attrib);

            if (shouldClearDebugDrawBuffers) {
                buffer->count = 0;
            }

            buffer = buffer->next;
        }
    }

    debugDraw->currentLineBuffer = debugDraw->lineBufferHead;
    if (shouldClearDebugDrawBuffers) {
        debugDraw->currentLineBuffer->count = 0;
    }


    // Screen Lines
    Texture *whiteTexture = GetTexture(Game.assets, DebugMem->white);
    if (lineProgram != NULL && whiteTexture != NULL) {
        DisableDepthTest(debugUIPass, screenLineKey);
        DisableDepthWrite(debugUIPass, screenLineKey);
        EnableBlending(debugUIPass, screenLineKey, GL_FUNC_ADD, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

        SetShader(debugUIPass, screenLineKey, lineProgram->programID);

        mat4 projection = Orthographic(0, Game.graphics->width, 0, Game.graphics->height, -1, 1);
        SetUniform(debugUIPass, screenLineKey, UniformLocation(lineProgram, "viewProjection"), projection);

        SetUniform(debugUIPass, lineKey, UniformLocation(lineProgram, "in_depth"), 0, whiteTexture->textureID, GL_TEXTURE_2D);
        SetSampler(debugUIPass, lineKey, 0, Game.graphics->nearestClampEdge);


        DebugDrawLineBuffer *buffer = debugDraw->screenLineBufferHead;
        while (buffer != NULL && buffer->count > 0) {
            BindBuffer(debugUIPass, screenLineKey, GL_ARRAY_BUFFER, buffer->bufferID);

            CopyBufferData(debugUIPass, screenLineKey, GL_ARRAY_BUFFER,
                           buffer->bufferSize, buffer->buffer, GL_STREAM_DRAW);

            EnableVertexAttribute(debugUIPass, screenLineKey,
                                  Position_Attrib, 3, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawLineVertex),
                                  FIELD_OFFSET(DebugDrawLineVertex, position));

            EnableVertexAttribute(debugUIPass, screenLineKey,
                                  Color_Attrib, 4, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawLineVertex),
                                  FIELD_OFFSET(DebugDrawLineVertex, color));

            EnableVertexAttribute(debugUIPass, screenLineKey,
                                  DashParam_Attrib, 1, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawLineVertex),
                                  FIELD_OFFSET(DebugDrawLineVertex, dashParam));

            EnableVertexAttribute(debugUIPass, screenLineKey,
                                  DepthFailScale_Attrib, 1, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawLineVertex),
                                  FIELD_OFFSET(DebugDrawLineVertex, depthFailScale));
            
            DrawArrays(debugUIPass, screenLineKey, PrimitiveType_Lines, 0, buffer->count);

            DisableVertexAttribute(debugUIPass, screenLineKey, Position_Attrib);
            DisableVertexAttribute(debugUIPass, screenLineKey, Color_Attrib);
            DisableVertexAttribute(debugUIPass, screenLineKey, DashParam_Attrib);
            DisableVertexAttribute(debugUIPass, screenLineKey, DepthFailScale_Attrib);
            if (shouldClearDebugDrawBuffers) {
                buffer->count = 0;
            }
            buffer = buffer->next;
        }
    }

    debugDraw->currentScreenLineBuffer = debugDraw->screenLineBufferHead;
    if (shouldClearDebugDrawBuffers) {
        debugDraw->currentScreenLineBuffer->count = 0;
    }

    // Mesh Instances
    ShaderProgram *meshProgram = GetShaderProgram(Game.assets, debugDraw->meshShader);

    if (meshProgram != NULL) {

        DisableDepthTest(debugUIPass, meshKey);
        DisableDepthWrite(debugUIPass, meshKey);

        EnableBlending(debugUIPass, meshKey, GL_FUNC_ADD, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

        SetShader(debugUIPass, meshKey, meshProgram->programID);

        SetUniform(debugUIPass, meshKey, UniformLocation(meshProgram, "viewProjection"), cameraUniformBuffer->viewProjection);
        
        SetUniform(debugUIPass, meshKey, UniformLocation(meshProgram, "in_depth"), 0, Game.graphics->gbufferTargets[0].depthTarget, GL_TEXTURE_2D);
        SetSampler(debugUIPass, meshKey, 0, Game.graphics->nearestClampEdge);
        
        DebugDrawMeshInstanceBuffer *buffer = debugDraw->meshInstanceBufferHead;
        while (buffer != NULL) {
            if (buffer->count > 0) {
                Mesh *mesh = GetMesh(Game.assets, buffer->meshHandle);
                if (mesh != NULL && mesh->positions != NULL) {

                    if (buffer->wireframe) {
                        EnableWireframe(debugUIPass, meshKey);
                    }

                    EnableBlending(debugUIPass, meshKey, GL_FUNC_ADD, GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

                    BindBuffer(debugUIPass, meshKey, GL_ARRAY_BUFFER, mesh->vboID);
                    BindBuffer(debugUIPass, meshKey, GL_ELEMENT_ARRAY_BUFFER, mesh->iboID);

                    EnableVertexAttribute(debugUIPass, meshKey, Position_Attrib,
                                          3, GL_FLOAT, GL_FALSE, 0,
                                          (uint8 *)mesh->positions - (uint8 *)mesh->vertices);

                    BindBuffer(debugUIPass, meshKey, GL_ARRAY_BUFFER, buffer->bufferID);
                    CopyBufferData(debugUIPass, meshKey, GL_ARRAY_BUFFER, buffer->bufferSize, buffer->buffer, GL_STREAM_DRAW);

                    uint32 instanceDataStride = sizeof(mat4) + sizeof(vec4) + sizeof(real32);
                    EnableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col0_Attrib,
                                          4, GL_FLOAT, GL_FALSE, instanceDataStride, 0, 1);
                    EnableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col1_Attrib,
                                          4, GL_FLOAT, GL_FALSE, instanceDataStride, 16, 1);
                    EnableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col2_Attrib,
                                          4, GL_FLOAT, GL_FALSE, instanceDataStride, 32, 1);
                    EnableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col3_Attrib,
                                          4, GL_FLOAT, GL_FALSE, instanceDataStride, 48, 1);
                    EnableVertexAttribute(debugUIPass, meshKey, Color_Attrib,
                                          4, GL_FLOAT, GL_TRUE, instanceDataStride, 64, 1);
                    EnableVertexAttribute(debugUIPass, meshKey, DepthFailScale_Attrib,
                                          1, GL_FLOAT, GL_FALSE, instanceDataStride, 80, 1);

                    DrawIndexedInstanced(debugUIPass, meshKey, mesh->primitiveType, 0, mesh->indexCount, buffer->count);

                    DisableVertexAttribute(debugUIPass, meshKey, Position_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col0_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col1_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col2_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col3_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, Color_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, DepthFailScale_Attrib);

                    DisableBlending(debugUIPass, meshKey);

                    if (buffer->wireframe) {
                        DisableWireframe(debugUIPass, meshKey);
                    }
                }
            }
            else {
                break;
            }

            if (shouldClearDebugDrawBuffers) {
                buffer->count = 0;
            }
            buffer = buffer->next;
        }

        buffer = debugDraw->screenMeshInstanceBufferHead;

        SetShader(debugUIPass, meshKey, meshProgram->programID);

        int32 width = Game.graphics->width;
        mat4 projection = Orthographic(0, Game.graphics->width, 0, Game.graphics->height, -width, width);
        SetUniform(debugUIPass, meshKey, UniformLocation(meshProgram, "viewProjection"), projection);

        SetUniform(debugUIPass, meshKey, UniformLocation(meshProgram, "in_depth"), 0, Game.graphics->gbufferTargets[0].depthTarget, GL_TEXTURE_2D);
        SetSampler(debugUIPass, meshKey, 0, Game.graphics->nearestClampEdge);
        
        while (buffer != NULL) {
            if (buffer->count > 0) {
                Mesh *mesh = GetMesh(Game.assets, buffer->meshHandle);
                if (mesh != NULL && mesh->positions != NULL) {

                    if (buffer->wireframe) {
                        EnableWireframe(debugUIPass, meshKey);
                    }

                    BindBuffer(debugUIPass, meshKey, GL_ARRAY_BUFFER, mesh->vboID);
                    BindBuffer(debugUIPass, meshKey, GL_ELEMENT_ARRAY_BUFFER, mesh->iboID);

                    EnableVertexAttribute(debugUIPass, meshKey, Position_Attrib,
                                          3, GL_FLOAT, GL_FALSE, 0,
                                          (uint8 *)mesh->positions - (uint8 *)mesh->vertices);

                    BindBuffer(debugUIPass, meshKey, GL_ARRAY_BUFFER, buffer->bufferID);
                    CopyBufferData(debugUIPass, meshKey, GL_ARRAY_BUFFER, buffer->bufferSize, buffer->buffer, GL_STREAM_DRAW);

                    uint32 instanceDataStride = sizeof(mat4) + sizeof(vec4) + sizeof(real32);
                    EnableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col0_Attrib,
                                          4, GL_FLOAT, GL_FALSE, instanceDataStride, 0, 1);
                    EnableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col1_Attrib,
                                          4, GL_FLOAT, GL_FALSE, instanceDataStride, 16, 1);
                    EnableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col2_Attrib,
                                          4, GL_FLOAT, GL_FALSE, instanceDataStride, 32, 1);
                    EnableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col3_Attrib,
                                          4, GL_FLOAT, GL_FALSE, instanceDataStride, 48, 1);
                    EnableVertexAttribute(debugUIPass, meshKey, Color_Attrib,
                                          4, GL_FLOAT, GL_TRUE, instanceDataStride, 64, 1);
                    EnableVertexAttribute(debugUIPass, meshKey, DepthFailScale_Attrib,
                                          1, GL_FLOAT, GL_FALSE, instanceDataStride, 80, 1);

                    DrawIndexedInstanced(debugUIPass, meshKey, mesh->primitiveType, 0, mesh->indexCount, buffer->count);

                    DisableVertexAttribute(debugUIPass, meshKey, Position_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col0_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col1_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col2_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, InstanceMat4_Col3_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, Color_Attrib);
                    DisableVertexAttribute(debugUIPass, meshKey, DepthFailScale_Attrib);

                    if (buffer->wireframe) {
                        DisableWireframe(debugUIPass, meshKey);
                    }
                }
            }
            else {
                break;
            }

            if (shouldClearDebugDrawBuffers) {
                buffer->count = 0;
            }
            buffer = buffer->next;
        }
    }

    // Text
    ShaderProgram *textProgram = GetShaderProgram(Game.assets, debugDraw->textShader);
    FontTable *font = DebugMem->debugFont;

    // @BUG: text does not rotate. We cant put a rotation per buffer because the buffer could have glyphs from
    // different calls, so we just put it on each glyph currently, but we're doing something wrong
    if (textProgram != NULL && font != NULL) {

        DebugDrawTextInstanceBuffer *buffer = debugDraw->textInstanceBufferHead;

        // Setup shader
        SetShader(debugUIPass, textKey, textProgram->programID);

        SetUniform(debugUIPass, textKey, UniformLocation(textProgram, "model"), buffer->model);

        SetUniform(debugUIPass, textKey, UniformLocation(textProgram, "viewProjection"), cameraUniformBuffer->viewProjection);
            
        SetUniform(debugUIPass, textKey, UniformLocation(textProgram, "texcoordsMap"),
                   0, font->texcoordsMapID, GL_TEXTURE_1D);

        SetSampler(debugUIPass, textKey, 0, Game.graphics->nearestClampEdge);
        SetUniform(debugUIPass, textKey, UniformLocation(textProgram, "atlas"),
                   1, font->atlas.textureID, GL_TEXTURE_2D);
        SetSampler(debugUIPass, textKey, 1, Game.graphics->linearClampEdge);

        // Setup GlyphQuad
        BindBuffer(debugUIPass, textKey, GL_ARRAY_BUFFER, Game.graphics->glyphQuad.vboID);
        BindBuffer(debugUIPass, textKey, GL_ELEMENT_ARRAY_BUFFER, Game.graphics->glyphQuad.iboID);

        EnableVertexAttribute(debugUIPass, textKey, Position_Attrib, 3, GL_FLOAT, GL_FALSE, 0,
                              POINTER_OFFSET(Game.graphics->glyphQuad.vertices, Game.graphics->glyphQuad.positions));

        EnableVertexAttribute(debugUIPass, textKey, TexCoord_Attrib, 2, GL_FLOAT, GL_FALSE, 0,
                              POINTER_OFFSET(Game.graphics->glyphQuad.vertices, Game.graphics->glyphQuad.texcoords));

        while (buffer != NULL && buffer->count > 0) {
            SetUniform(debugUIPass, textKey, UniformLocation(textProgram, "model"), buffer->model);
            
            BindBuffer(debugUIPass, textKey, GL_ARRAY_BUFFER, buffer->bufferID);
            CopyBufferData(debugUIPass, textKey, GL_ARRAY_BUFFER, buffer->bufferSize, buffer->buffer, GL_STREAM_DRAW);
                
            EnableVertexIAttribute(debugUIPass, textKey, GlyphCodepoint_Attrib, 1, GL_UNSIGNED_INT,
                                   sizeof(DebugDrawTextInstanceData),
                                   FIELD_OFFSET(DebugDrawTextInstanceData, codepoint), 1);

            EnableVertexAttribute(debugUIPass, textKey, GlyphPosition_Attrib, 3, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawTextInstanceData),
                                  FIELD_OFFSET(DebugDrawTextInstanceData, position), 1);

            EnableVertexAttribute(debugUIPass, textKey, GlyphDimensions_Attrib, 2, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawTextInstanceData),
                                  FIELD_OFFSET(DebugDrawTextInstanceData, scale), 1);

            EnableVertexAttribute(debugUIPass, textKey, Color_Attrib, 4, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawTextInstanceData),
                                  FIELD_OFFSET(DebugDrawTextInstanceData, color), 1);

            DrawIndexedInstanced(debugUIPass, textKey, PrimitiveType_Triangles, 0, 6, buffer->count);

            DisableVertexAttribute(debugUIPass, textKey, GlyphCodepoint_Attrib);
            DisableVertexAttribute(debugUIPass, textKey, GlyphPosition_Attrib);
            DisableVertexAttribute(debugUIPass, textKey, Rotation_Attrib);
            DisableVertexAttribute(debugUIPass, textKey, GlyphDimensions_Attrib);
            DisableVertexAttribute(debugUIPass, textKey, Color_Attrib);

            if (shouldClearDebugDrawBuffers) {
                buffer->count = 0;
            }
            buffer = buffer->next;
        }

        DisableVertexAttribute(debugUIPass, textKey, Position_Attrib);
        DisableVertexAttribute(debugUIPass, textKey, TexCoord_Attrib);
    }

    // Screen Text
    if (textProgram != NULL && font != NULL) {
        DebugDrawTextInstanceBuffer *buffer = debugDraw->screenTextInstanceBufferHead;

        // Setup Shader
        SetShader(debugUIPass, textKey, textProgram->programID);

        SetUniform(debugUIPass, textKey, UniformLocation(textProgram, "model"), Identity4());

        mat4 projection = Orthographic(0, Game.graphics->width, 0, Game.graphics->height, -1, 1);
        SetUniform(debugUIPass, textKey, UniformLocation(textProgram, "viewProjection"), projection); 

        SetUniform(debugUIPass, textKey, UniformLocation(textProgram, "texcoordsMap"), 0, font->texcoordsMapID, GL_TEXTURE_1D);

        SetSampler(debugUIPass, textKey, 0, Game.graphics->nearestClampEdge);
        SetUniform(debugUIPass, textKey, UniformLocation(textProgram, "atlas"), 1, font->atlas.textureID, GL_TEXTURE_2D);
        SetSampler(debugUIPass, textKey, 1, Game.graphics->linearClampEdge);

        // Setup GlyphQuad
        BindBuffer(debugUIPass, textKey, GL_ARRAY_BUFFER, Game.graphics->glyphQuad.vboID);
        BindBuffer(debugUIPass, textKey, GL_ELEMENT_ARRAY_BUFFER, Game.graphics->glyphQuad.iboID);

        EnableVertexAttribute(debugUIPass, textKey, Position_Attrib, 3, GL_FLOAT, GL_FALSE, 0,
                              POINTER_OFFSET(Game.graphics->glyphQuad.vertices, Game.graphics->glyphQuad.positions));

        EnableVertexAttribute(debugUIPass, textKey, TexCoord_Attrib, 2, GL_FLOAT, GL_FALSE, 0,
                              POINTER_OFFSET(Game.graphics->glyphQuad.vertices, Game.graphics->glyphQuad.texcoords));

        while (buffer != NULL && buffer->count > 0) {
            
            BindBuffer(debugUIPass, textKey, GL_ARRAY_BUFFER, buffer->bufferID);
            CopyBufferData(debugUIPass,textKey, GL_ARRAY_BUFFER, buffer->bufferSize, buffer->buffer, GL_STREAM_DRAW);

            EnableVertexIAttribute(debugUIPass, textKey, GlyphCodepoint_Attrib, 1, GL_UNSIGNED_INT,
                                   sizeof(DebugDrawTextInstanceData),
                                   FIELD_OFFSET(DebugDrawTextInstanceData, codepoint), 1);

            EnableVertexAttribute(debugUIPass, textKey, GlyphPosition_Attrib, 3, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawTextInstanceData),
                                  FIELD_OFFSET(DebugDrawTextInstanceData, position), 1);

            EnableVertexAttribute(debugUIPass, textKey, GlyphDimensions_Attrib, 2, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawTextInstanceData),
                                  FIELD_OFFSET(DebugDrawTextInstanceData, scale), 1);

            EnableVertexAttribute(debugUIPass, textKey, Color_Attrib, 4, GL_FLOAT, GL_FALSE,
                                  sizeof(DebugDrawTextInstanceData),
                                  FIELD_OFFSET(DebugDrawTextInstanceData, color), 1);

            DrawIndexedInstanced(debugUIPass, textKey, PrimitiveType_Triangles, 0, 6, buffer->count);

            DisableVertexAttribute(debugUIPass, textKey, GlyphCodepoint_Attrib);
            DisableVertexAttribute(debugUIPass, textKey, GlyphPosition_Attrib);
            //DisableVertexAttribute(debugUIPass, textKey, Rotation_Attrib);
            DisableVertexAttribute(debugUIPass, textKey, GlyphDimensions_Attrib);
            DisableVertexAttribute(debugUIPass, textKey, Color_Attrib);

            if (shouldClearDebugDrawBuffers) {
                buffer->count = 0;
            }
            buffer = buffer->next;
        }

        DisableVertexAttribute(debugUIPass, textKey, Position_Attrib);
        DisableVertexAttribute(debugUIPass, textKey, TexCoord_Attrib);
    }
}

void _DebugDrawLine(DebugDrawLineBuffer **currentBuffer, vec3 a, vec3 b, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    TIMED_BLOCK_LABEL("DebugDraw");
    
    DebugDrawLineBuffer *buffer = *currentBuffer;

    if (buffer->count > buffer->capacity - 2) {
        if (buffer->next) {
            buffer = buffer->next;
        }
        else {
            buffer->next = (DebugDrawLineBuffer *)Plat.AllocateMem(sizeof(DebugDrawLineBuffer));
            InitDebugDrawLineBuffer(buffer->next);

            buffer = buffer->next;
        }

        *currentBuffer = buffer;
    }

    real32 dashParamA;
    real32 dashParamB;

    if (dashLength <= 0.0f) {
        dashParamA = 0.0f;
        dashParamB = 0.0f;
    }
    else {
        real32 length = Distance(a, b);

        dashParamA = dashOffset;
        dashParamB = dashOffset + length / dashLength;
    }

    {
        DebugDrawLineVertex *vertex = buffer->buffer + buffer->count;
        vertex->position = a;
        vertex->color = color;
        vertex->dashParam = dashParamA;
        vertex->depthFailScale = depthFailScale;
        buffer->count += 1;
    }

    {
        DebugDrawLineVertex *vertex = buffer->buffer + buffer->count;
        vertex->position = b;
        vertex->color = color;
        vertex->dashParam = dashParamB;
        vertex->depthFailScale = depthFailScale;
        buffer->count += 1;
    }
}

void _DebugDrawMesh(DebugDrawMeshInstanceBuffer *buffer, MeshHandle mesh, vec3 position, quaternion rotation, vec3 scale, vec4 color, b32 wireframe, real32 depthFailScale) {
    TIMED_BLOCK_LABEL("DebugDraw");
    
    DebugDraw *debugDraw = &DebugMem->debugDraw;

    while (true) {
        if (buffer->count == 0) {
            buffer->meshHandle = mesh;
            buffer->wireframe = wireframe;
            break;
        }
        else if (buffer->meshHandle.asset == mesh.asset &&
                 buffer->wireframe == wireframe &&
                 buffer->count < buffer->capacity) {
            break;
        }

        if (buffer->next == NULL) {
            buffer->next = (DebugDrawMeshInstanceBuffer *)Plat.AllocateMem(sizeof(DebugDrawMeshInstanceBuffer));
            InitDebugDrawMeshInstanceBuffer(buffer->next);
        }

        buffer = buffer->next;
    }

    buffer->buffer[buffer->count].transform = TRS(position, rotation, scale);
    buffer->buffer[buffer->count].color = color;
    buffer->buffer[buffer->count].depthFailScale = depthFailScale;
    buffer->count++;
}

void DebugDrawLine(vec3 a, vec3 b, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    _DebugDrawLine(&DebugMem->debugDraw.currentLineBuffer, a, b, color, dashLength, dashOffset, depthFailScale);
}

void DebugDrawRay(Ray ray, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    _DebugDrawLine(&DebugMem->debugDraw.currentLineBuffer, ray.origin, ray.origin + ray.direction, color, dashLength, dashOffset, depthFailScale);   
}

void DebugDrawLineScreen(vec3 a, vec3 b, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    _DebugDrawLine(&DebugMem->debugDraw.currentScreenLineBuffer, a, b, color, dashLength, dashOffset, depthFailScale);
}

void DebugDrawLineScreen(vec2 a, vec2 b, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    _DebugDrawLine(&DebugMem->debugDraw.currentScreenLineBuffer, V3(a, 0), V3(b, 0), color, dashLength, dashOffset, depthFailScale);
}

void DebugDrawLineScreenNorm(vec3 a, vec3 b, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    DebugDrawLineScreen(Hadamard(a, V3(Game.graphics->width, Game.graphics->height, 1u)),
                        Hadamard(b, V3(Game.graphics->width, Game.graphics->height, 1u)),
                        color, dashLength, dashOffset, depthFailScale);
}

void DebugDrawLineScreenNorm(vec2 a, vec2 b, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    DebugDrawLineScreen(Hadamard(a, V2(Game.graphics->width, Game.graphics->height)),
                        Hadamard(b, V2(Game.graphics->width, Game.graphics->height)),
                        color, dashLength, dashOffset, depthFailScale);

}

void DebugDrawPoint(vec3 a, vec4 color, real32 scale, real32 depthFailScale) {
    real32 halfScale = 0.5f * scale;

    DebugDrawLine(a - V3(halfScale, 0, 0), a + V3(halfScale, 0, 0), color, 0, 0, depthFailScale);
    DebugDrawLine(a - V3(0, halfScale, 0), a + V3(0, halfScale, 0), color, 0, 0, depthFailScale);
    DebugDrawLine(a - V3(0, 0, halfScale), a + V3(0, 0, halfScale), color, 0, 0, depthFailScale);
}

void DebugDrawPointScreen(vec2 a, vec4 color, real32 scale, real32 depthFailScale) {
    real32 halfScale = 0.5f * scale;

    DebugDrawLineScreen(a - V2(halfScale, 0), a + V2(halfScale, 0), color, 0, 0, depthFailScale);
    DebugDrawLineScreen(a - V2(0, halfScale), a + V2(0, halfScale), color, 0, 0, depthFailScale);
}

void DebugDrawCoordinateSystem(vec3 position, vec3 X, vec3 Y, vec3 Z, real32 scale, real32 depthFailScale) {
    DebugDrawLine(position, position + X * scale, RED, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(position, position + Y * scale, GREEN, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(position, position + Z * scale, BLUE, 0.0f, 0.0f, depthFailScale);
}

void DebugDrawCoordinateSystem(vec3 position, quaternion rotation, real32 scale, real32 depthFailScale) {
    vec3 X = Rotate(rotation, V3(1, 0, 0));
    vec3 Y = Rotate(rotation, V3(0, 1, 0));
    vec3 Z = Rotate(rotation, V3(0, 0, 1));

    DebugDrawCoordinateSystem(position, X, Y, Z, scale, depthFailScale);
}

void DebugDrawPlane(vec3 point, vec3 normal, vec4 color, bool showNormal, vec2 scale) {
    vec3 X, Y;
    ConstructBasis(normal, &X, &Y);
    
    quaternion rot = QuaternionWithYZ(normal, X);
    vec3 center = point - (0.5f * Normalize(X) * scale.x) + (0.5f * Normalize(Y) * scale.y);

    if (showNormal) {
        DebugDrawLine(center, center + normal, color);
    }

    DebugDrawMesh(DebugMem->quad, center, rot, V3(scale.x, 1, scale.y), color);
}

void DebugDrawPlane(Plane plane, vec4 color, bool showNormal, vec2 scale) {
    DebugDrawPlane(plane.point, plane.normal, color, showNormal, scale);
}

void DebugDrawTriangle(vec3 a, vec3 b, vec3 c, vec4 color) {
    DebugDrawLine(a, b, color);
    DebugDrawLine(b, c, color);
    DebugDrawLine(a, c, color);
}

void DebugDrawTriangle(vec3 *verts, vec4 color) {
    DebugDrawTriangle(verts[0], verts[1], verts[2], color);
}

void DebugDrawRect(vec3 position, vec3 X, vec3 Y, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    DebugDrawLine(position, position + X, color, dashLength, dashOffset, depthFailScale);
    DebugDrawLine(position, position + Y, color, dashLength, dashOffset, depthFailScale);
    DebugDrawLine(position + Y, position + Y + X, color, dashLength, dashOffset, depthFailScale);
    DebugDrawLine(position + X, position + X + Y, color, dashLength, dashOffset, depthFailScale);
}

void DebugDrawRect(vec3 position, quaternion rotation, vec2 scale, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    vec3 X = Rotate(rotation, V3(1, 0, 0));
    vec3 Y = Rotate(rotation, V3(0, 1, 0));

    DebugDrawRect(position, X * scale.x, Y * scale.y, color, dashLength, dashOffset, depthFailScale);
}

void DebugDrawCenteredRect(vec3 position, quaternion rotation, vec2 scale, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    vec3 X = Rotate(rotation, V3(1, 0, 0)) * scale.x;
    vec3 Y = Rotate(rotation, V3(0, 1, 0)) * scale.y;

    vec3 lowerLeft = position - X * 0.5f - Y * 0.5f;
    DebugDrawRect(lowerLeft, X, Y, color, dashLength, dashOffset, depthFailScale);
}

void DebugDrawRectScreen(vec2 position, vec2 scale, vec4 color, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    DebugDrawLineScreen(position, position + V2(scale.x, 0), color, dashLength, dashOffset, depthFailScale);
    DebugDrawLineScreen(position, position + V2(0, scale.y), color, dashLength, dashOffset, depthFailScale);
    DebugDrawLineScreen(position + V2(0, scale.y), position + scale, color, dashLength, dashOffset, depthFailScale);
    DebugDrawLineScreen(position + V2(scale.x, 0), position + scale, color, dashLength, dashOffset, depthFailScale);
}

void DebugDrawAABB(AABB aabb, Transform transform, vec4 color, real32 depthFailScale) {
    vec3 min = aabb.center - aabb.halfExtents;
    vec3 max = aabb.center + aabb.halfExtents;

    vec3 points[] = {
        MultiplyPoint(transform, V3(min.x, min.y, min.z)),
        MultiplyPoint(transform, V3(max.x, min.y, min.z)),
        MultiplyPoint(transform, V3(max.x, min.y, max.z)),
        MultiplyPoint(transform, V3(min.x, min.y, max.z)),

        MultiplyPoint(transform, V3(min.x, max.y, min.z)),
        MultiplyPoint(transform, V3(max.x, max.y, min.z)),
        MultiplyPoint(transform, V3(max.x, max.y, max.z)),
        MultiplyPoint(transform, V3(min.x, max.y, max.z)),
    };

    DebugDrawLine(points[0], points[1], color, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(points[1], points[2], color, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(points[2], points[3], color, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(points[3], points[0], color, 0.0f, 0.0f, depthFailScale);

    DebugDrawLine(points[0], points[4], color, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(points[1], points[5], color, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(points[2], points[6], color, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(points[3], points[7], color, 0.0f, 0.0f, depthFailScale);

    DebugDrawLine(points[4], points[5], color, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(points[5], points[6], color, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(points[6], points[7], color, 0.0f, 0.0f, depthFailScale);
    DebugDrawLine(points[7], points[4], color, 0.0f, 0.0f, depthFailScale);
}

void DebugDrawAABB(vec3 center, vec3 halfExtents, vec4 color, real32 depthFailScale) {
    DebugDrawAABB({center, halfExtents}, IdentityTransform(), color, depthFailScale);
}

void DebugDrawAABB(AABB aabb, vec3 position, vec4 color, real32 depthFailScale) {
    DebugDrawAABB({aabb.center + position, aabb.halfExtents}, IdentityTransform(), color, depthFailScale);
}

void DebugDrawGrid(vec3 origin, vec3 X, vec3 Y, real32 majorSpacing, int32 majorSegments, int32 minorSegments, vec4 majorColor, vec4 minorColor, real32 depthFailScale) {
    real32 minorSpacing = majorSpacing / minorSegments;

    real32 xMin = -(majorSegments / 2) * majorSpacing;
    real32 xMax = (majorSegments / 2) * majorSpacing;

    real32 yMin = -(majorSegments / 2) * majorSpacing;
    real32 yMax = (majorSegments / 2) * majorSpacing;


    for (int i = 0; i <= majorSegments; i++) {
        real32 x = xMin + i * majorSpacing;
        DebugDrawLine(origin + X * x + Y * yMin,
                      origin + X * x + Y * yMax,
                      majorColor,
                      0.0f, 0.0f, depthFailScale);
            
        if (i < majorSegments) {
            for (int j = 1; j < minorSegments; j++) {
                real32 minorX = x + j * minorSpacing;
                DebugDrawLine(origin + X * minorX + Y * yMin,
                              origin + X * minorX + Y * yMax,
                              minorColor,
                              0.0f, 0.0f, depthFailScale);
            }
        }
    }

    for (int i = 0; i <= majorSegments; i++) {
        real32 y = yMin + i * majorSpacing;
        DebugDrawLine(origin + X * xMin + Y * y,
                      origin + X * xMax + Y * y,
                      majorColor,
                      0.0f, 0.0f, depthFailScale);
            
        if (i < majorSegments) {
            for (int j = 1; j < minorSegments; j++) {
                real32 minorY = y + j * minorSpacing;
                DebugDrawLine(origin + X * xMin + Y * minorY,
                              origin + X * xMax + Y * minorY,
                              minorColor,
                              0.0f, 0.0f, depthFailScale);
            }
        }
    }
}

void DebugDrawQuadScreen(vec2 position, vec2 scale, vec4 color, real32 depthFailScale) {
    quaternion rotation = AxisAngle(V3(0, 1, 0), _PI * 0.5f) * AxisAngle(V3(0, 0, 1), _PI * 0.5f);
    _DebugDrawMesh(DebugMem->debugDraw.screenMeshInstanceBufferHead, DebugMem->quad, V3(position, 0), rotation, V3(scale.y, 0.0f, scale.x), color, false, depthFailScale);
}

void DebugDrawCircle(vec3 center, real32 radius, vec3 normal, vec4 color, uint32 segments, real32 depthFailScale) {
    vec3 X, Y;
    ConstructBasis(normal, &X, &Y);

    for (int i = 0; i < segments; i++) {
        real32 theta0 = 2 * _PI * i / (real32)(segments);
        real32 theta1 = 2 * _PI * (i + 1.0f) / (real32)(segments);

        vec3 p0 = X * radius * cosf(theta0) + Y * radius * sinf(theta0);
        vec3 p1 = X * radius * cosf(theta1) + Y * radius * sinf(theta1);

        DebugDrawLine(center + p0, center + p1, color, 0.0f, 0.0f, depthFailScale);
    }
}

void DebugDrawCircleScreen(vec2 center, real32 radius, vec4 color, uint32 segments) {
    vec3 X, Y;
    ConstructBasis(V3(0, 0, 1), &X, &Y);

    for (int i = 0; i < segments; i++) {
        real32 theta0 = 2 * _PI * i / (real32)(segments);
        real32 theta1 = 2 * _PI * (i + 1.0f) / (real32)(segments);

        vec3 p0 = X * radius * cosf(theta0) + Y * radius * sinf(theta0);
        vec3 p1 = X * radius * cosf(theta1) + Y * radius * sinf(theta1);

        DebugDrawLineScreen(V2(center.x + p0.x, center.y + p0.y),
                            V2(center.x + p1.x, center.y + p1.y), color, 0.0f, 0.0f);
    }
}

void DebugDrawArc(vec3 center, real32 radius, vec3 normal, vec3 X, real32 startAngle, real32 endAngle, vec4 color, uint32 segments, real32 depthFailScale) {

    vec3 Y = Cross(X, normal);

    for (int i = 0; i < segments; i++) {
        real32 theta0 = Lerp(startAngle, endAngle, i / (real32)(segments));
        real32 theta1 = Lerp(startAngle, endAngle, (i + 1.0f) / (real32)(segments));

        vec3 p0 = X * radius * cosf(theta0) + Y * radius * sinf(theta0);
        vec3 p1 = X * radius * cosf(theta1) + Y * radius * sinf(theta1);

        DebugDrawLine(center + p0, center + p1, color, 0.0f, 0.0f, depthFailScale);
    }
}

void DebugDrawArcScreen(vec2 center, real32 radius, real32 startAngle, real32 endAngle, vec4 color, uint32 segments, real32 depthFailScale) {
    vec3 X, Y;
    ConstructBasis(V3(0, 0, 1), &X, &Y);

    for (int i = 0; i < segments; i++) {
        real32 theta0 = Lerp(startAngle, endAngle, i / (real32)(segments));
        real32 theta1 = Lerp(startAngle, endAngle, (i + 1.0f) / (real32)(segments));

        vec3 p0 = X * radius * cosf(theta0) + Y * radius * sinf(theta0);
        vec3 p1 = X * radius * cosf(theta1) + Y * radius * sinf(theta1);

        DebugDrawLineScreen(V2(center.x + p0.x, center.y + p0.y),
                            V2(center.x + p1.x, center.y + p1.y), color, 0.0f, 0.0f);
    }
}

void DebugDrawBezier(vec3 a, vec3 b, vec3 c, vec3 d, vec4 color, uint32 segments, real32 dashLength, real32 dashOffset, real32 depthFailScale) {
    real32 t;
    vec3 currPoint;
    vec3 prevPoint = a;

    real32 dashOffset_ = dashOffset;

    for (int i = 1; i <= segments; i++) {
        t = i / (real32)segments;
        currPoint = BezierCubic(a, b, c, d, t);

        DebugDrawLine(prevPoint, currPoint, color, dashLength, dashOffset_, depthFailScale);

        if (dashLength > 0.0f) {
            real32 length = Distance(prevPoint, currPoint);
            dashOffset_ += length / dashLength;
        }
        prevPoint = currPoint;
    }
}

void DebugDrawBezierScreen(vec2 a, vec2 b, vec2 c, vec2 d, vec4 color, uint32 segments) {
    real32 t;
    vec2 currPoint;
    vec2 prevPoint = a;

    for (int i = 1; i <= segments; i++) {
        t = i / (real32)segments;
        vec2 val = BezierCubic(a, b, c, d, t);

        currPoint = val;
        DebugDrawLineScreen(prevPoint, currPoint, color, 0.0f, 0.0f);

        prevPoint = currPoint;
    }
}

void DebugDrawCatmullRom(vec3 a, vec3 b, vec3 c, vec3 d, real32 alpha, vec4 color, uint32 segments, real32 depthFailScale) {

    real32 t0, t1, t2, t3;
    CatmullRomKnots(a, b, c, d, alpha, &t0, &t1, &t2, &t3);
    
    real32 t;
    vec3 currPoint;
    vec3 prevPoint = b;

    for (int i = 1; i <= segments; i++) {
        t = Lerp(t1, t2, i / (real32)segments);
        vec3 val = CatmullRom(a, b, c, d, t0, t1, t2, t3, t);

        currPoint = val;
        DebugDrawLine(prevPoint, currPoint, color, 0.0f, 0.0f, depthFailScale);

        prevPoint = currPoint;
    }
}

// @TODO: animate!
// @NOTE: position is the bottom
// @TODO: define various poses, I think these can be defined by x/y positions of vairous appendages,
// for instance grabbing ammo from pouch is changing end position of hand
void DebugDrawStickFigure(vec2 position, vec2 scale, vec4 color, bool reloading, bool failed) {

#if 0
    vec2 dimensionsOffset = V2(40, 0);
    DebugDrawScreenPoint(position + dimensionsOffset, MAGENTA, 20);
    DebugDrawScreenLine(position + dimensionsOffset, position + dimensionsOffset + V2(0, scale.y), MAGENTA);
    DebugDrawScreenLine(position + dimensionsOffset + V2(scale.x * 0.5f, 0),
                        position + dimensionsOffset - V2(scale.x * 0.5f, 0), MAGENTA);
#endif

    // @NOTE: the legs are %40 of height, arms body %35, and height %20

    // @TODO: knee joints
    real32 legLength = scale.y * 0.4f;

    // @Note: this is right and left on the screen, not of the body
    vec2 rightPosition = V2(position.x + scale.x * 0.125f, position.y);
    vec2 leftPosition =  V2(position.x - scale.x * 0.125f, position.y);

    vec2 groinPosition = V2(position.x, position.y + legLength);

    // // legs
    DebugDrawLineScreen(rightPosition, groinPosition, color);
    DebugDrawLineScreen(leftPosition, groinPosition, color);

    real32 bodyLength = scale.y * 0.35f;
    vec2 neckPosition = V2(position.x, position.y + legLength + bodyLength);
    DebugDrawLineScreen(groinPosition, neckPosition, color);

    vec2 shoulderPosition = V2(position.x, position.y + legLength + bodyLength * 0.7f);

    vec2 rightElbowPosition = V2(position.x + scale.x * 0.125f, groinPosition.y * 1.25f);
    vec2 leftElbowPosition = V2(position.x - scale.x * 0.125f, groinPosition.y * 1.25f);

    DebugDrawLineScreen(shoulderPosition, rightElbowPosition, color);
    DebugDrawLineScreen(shoulderPosition, leftElbowPosition, color);

    vec2 rightHandPosition = V2(position.x + scale.x * 0.15f, groinPosition.y);

    if (reloading) {
        rightHandPosition = V2(position.x, groinPosition.y);    
    }
    
    vec2 leftHandPosition = V2(position.x - scale.x * 0.15f, groinPosition.y);
    DebugDrawLineScreen(rightElbowPosition, rightHandPosition, color);
    DebugDrawLineScreen(leftElbowPosition, leftHandPosition, color);

    real32 headRadius = scale.y * 0.125f;
    vec2 headCenter = V2(position.x, position.y + legLength + bodyLength + headRadius);
    DebugDrawCircleScreen(headCenter, headRadius, color);

    // eyes
    DebugDrawCircleScreen(headCenter + V2(headRadius * 0.5f, 0), headRadius * 0.2f);
    DebugDrawCircleScreen(headCenter - V2(headRadius * 0.5f, 0), headRadius * 0.2f);

    vec2 leftMouth = headCenter + V2(-headRadius * 0.3f, -headRadius * 0.5f);
    vec2 rightMouth = headCenter + V2(headRadius * 0.3f, -headRadius * 0.5f);
    DebugDrawLineScreen(leftMouth, rightMouth, color);
        
    if (failed) {
        DebugDrawLineScreen(leftMouth + V2(-4, -2), leftMouth , color);
        DebugDrawLineScreen(rightMouth + V2(4, -2), rightMouth , color);
    }
}

void DebugDrawSphere(vec3 position, real32 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.meshInstanceBufferHead, DebugMem->sphere, position, IdentityQuaternion(), V3(scale, scale, scale), color, false, depthFailScale);
}

void DebugDrawSphereWireframe(vec3 position, real32 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.meshInstanceBufferHead, DebugMem->sphere, position, IdentityQuaternion(), V3(scale, scale, scale), color, true, depthFailScale);
}

void DebugDrawMesh(MeshHandle mesh, vec3 position, quaternion rotation, real32 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.meshInstanceBufferHead, mesh, position, rotation, V3(scale, scale, scale), color, false, depthFailScale);
}

void DebugDrawMesh(MeshHandle mesh, vec3 position, quaternion rotation, vec3 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.meshInstanceBufferHead, mesh, position, rotation, scale, color, false, depthFailScale);
}

void DebugDrawMesh(MeshHandle mesh, vec3 position, real32 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.meshInstanceBufferHead, mesh, position, AxisAngle(V3(0, 1, 0), 0), V3(scale, scale, scale), color, false, depthFailScale);
}

void DebugDrawMesh(MeshHandle mesh, vec3 position, vec3 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.meshInstanceBufferHead, mesh, position, AxisAngle(V3(0, 1, 0), 0), scale, color, false, depthFailScale);
}

void DebugDrawMeshWireframe(MeshHandle mesh, vec3 position, quaternion rotation, real32 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.meshInstanceBufferHead, mesh, position, rotation, V3(scale, scale, scale), color, true, depthFailScale);
}
    
void DebugDrawMeshWireframe(MeshHandle mesh, vec3 position, real32 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.meshInstanceBufferHead, mesh, position, AxisAngle(V3(0, 1, 0), 0), V3(scale, scale, scale), color, true, depthFailScale);
}

void DebugDrawMeshWireframe(MeshHandle mesh, vec3 position, quaternion rotation, vec3 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.meshInstanceBufferHead, mesh, position, rotation, scale, color, true, depthFailScale);
}
    
void DebugDrawMeshWireframe(MeshHandle mesh, vec3 position, vec3 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.meshInstanceBufferHead, mesh, position, AxisAngle(V3(0, 1, 0), 0), scale, color, true, depthFailScale);
}

void DebugDrawMeshScreen(MeshHandle mesh, vec2 position, quaternion rotation, vec3 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.screenMeshInstanceBufferHead, mesh, V3(position, 0), rotation, scale, color, false, depthFailScale);
}

void DebugDrawMeshScreen(MeshHandle mesh, vec2 position, vec3 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.screenMeshInstanceBufferHead, mesh, V3(position, 0), IdentityQuaternion(), scale, color, false, depthFailScale);
}

void DebugDrawMeshScreen(MeshHandle mesh, vec2 position, real32 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.screenMeshInstanceBufferHead, mesh, V3(position, 0), IdentityQuaternion(), V3(scale, scale, scale), color, false, depthFailScale);
}

void DebugDrawMeshScreenNorm(MeshHandle mesh, vec2 position, real32 scale, vec4 color, real32 depthFailScale) {
    _DebugDrawMesh(DebugMem->debugDraw.screenMeshInstanceBufferHead, mesh, Hadamard(V3(position, 0), V3(Game.graphics->width * 1.0f, Game.graphics->height * 1.0f, 0)), IdentityQuaternion(), V3(scale, scale, scale), color, false, depthFailScale);
}

void DebugDrawMeshNormals(Mesh *mesh, real32 normalScale, vec3 position, quaternion rotation, real32 scale, vec4 color, real32 depthFailScale) {
    mat4 transform = TRS(position, rotation, scale);

    if (mesh != NULL && mesh->positions != NULL && mesh->normals != NULL) {
        for (int i = 0; i < mesh->vertexCount; i++) {
            vec3 vertexPosition = MultiplyPoint(transform, mesh->positions[i]);
            vec3 normal = Rotate(rotation, mesh->normals[i]) * scale * normalScale;

            DebugDrawLine(vertexPosition, vertexPosition + normal, color, 0.0f, 0.0f, depthFailScale);
        }
    }
}

// @GACK @TODO: get rid of this and just do it threw drawcodepoints
void _DebugDrawCodepoints(DebugDrawTextInstanceBuffer *buffer, FontTable *font, vec3 position, quaternion rotation, real32 size, vec4 color, vec2 *dimensions, vec2 *positions, uint32 *lineCount, uint32 *codepoints, uint32 codepointCount, real32 maxX) {
    DebugDraw *debugDraw = &DebugMem->debugDraw;

    real32 lineHeight = font->lineHeight * size;

    real32 x = 0.0f;

    *lineCount = 1;
    real32 y = 0.0f;
    for (int i = 0; i < codepointCount; i++) {
        if (buffer->count >= buffer->capacity) {
            if (buffer->next != NULL) {
                buffer = buffer->next;
            }
            else {
                buffer->next =
                    (DebugDrawTextInstanceBuffer *)Plat.AllocateMem(sizeof(DebugDrawTextInstanceBuffer));
                InitDebugDrawTextInstanceBuffer(buffer->next);

                buffer = buffer->next;
            }
        }
        
        uint32 bufferIndex = buffer->count;
            
        uint32 codepoint = GetInternalCodepoint(font, codepoints[i]);
        GlyphInfo info = GetGlyphInfo(font, codepoint);
        real32 advance = size;

        if (IsNewline(codepoints[i])) {
            *lineCount += 1;
            y -= lineHeight;
            x = 0.0f;
        }
        else {
            if (x > maxX) {
                x = 0.0f;
                y -= lineHeight;
            }
            
            buffer->buffer[bufferIndex].codepoint = codepoint;
            buffer->buffer[bufferIndex].scale = V2(info.size.x, info.size.y) * size;
            buffer->buffer[bufferIndex].color = color;
            buffer->buffer[bufferIndex].rotation = rotation;
            
            if (!IsSpace(codepoint)) {
                buffer->buffer[bufferIndex].position = V3(x + size * info.lowerLeft.x,
                                                          y + info.lowerLeft.y * size, 0.0f) + position;
            }
            else {
                buffer->buffer[bufferIndex].position = V3(x, 0.0f, 0.0f) + position;
            }

            positions[i] = V2(buffer->buffer[bufferIndex].position.x,
                              buffer->buffer[bufferIndex].position.y);

            x += advance;

            buffer->count += 1;
        }
    }

    if (dimensions != NULL) {
        dimensions->x = maxX;
        if (*lineCount == 1) {
            dimensions->y = lineHeight;
        }
        else {
            dimensions->y = y;
        }
    }
}

void DebugDrawCodepoints(vec3 position, quaternion rotation, real32 size, vec4 color, vec2 *dimensions, vec2 *positions, uint32 *lineCount, uint32 *codepoints, uint32 codepointCount, real32 maxX) {
    _DebugDrawCodepoints(DebugMem->debugDraw.textInstanceBufferHead, DebugMem->debugFont, position, rotation, size, color, dimensions,positions, lineCount, codepoints, codepointCount, maxX);
}

void DebugDrawCodepointsScreen(vec2 position, real32 size, vec4 color, vec2 *dimensions, vec2 *positions, uint32 *lineCount, uint32 *codepoints, uint32 codepointCount, real32 maxX) {
    _DebugDrawCodepoints(DebugMem->debugDraw.screenTextInstanceBufferHead, DebugMem->debugFont, V3(position, 0), IdentityQuaternion(), size, color, dimensions, positions, lineCount, codepoints, codepointCount, maxX);
}

void DebugDrawCodepointsScreen(vec2 position, FontTable *font, real32 size, vec4 color, vec2 *dimensions, vec2 *positions, uint32 *lineCount, uint32 *codepoints, uint32 codepointCount, real32 maxX) {
    _DebugDrawCodepoints(DebugMem->debugDraw.screenTextInstanceBufferHead, font, V3(position, 0), IdentityQuaternion(), size, color, dimensions, positions, lineCount, codepoints, codepointCount, maxX);
}

void _DebugDrawText(DebugDrawTextInstanceBuffer *buffer, vec3 position, quaternion rotation, real32 size, vec4 color, int32 cursorAt, b32 cursorScreen, vec2 *dimensions, const char *format, va_list args) {
    DebugDraw *debugDraw = &DebugMem->debugDraw;

    FontTable *font = DebugMem->debugFont;
    if (font == NULL) {
        return;
    }

    //TIMED_BLOCK();

    // @TODO: stb_sprintf would mean there isn't a maximum bound!
    char textBuffer[DEBUG_TEXT_MAX_LENGTH];
    vsnprintf(textBuffer, DEBUG_TEXT_MAX_LENGTH, format, args);

    uint32 length = strlen(textBuffer);
    real32 lineHeight = font->lineHeight * size;

    // if (buffer->count > 0) {
    //     buffer->next = (DebugDrawTextInstanceBuffer *)Plat.AllocateMem(sizeof(DebugDrawTextInstanceBuffer));
    //     InitDebugDrawTextInstanceBuffer(buffer->next);

    //     buffer = buffer->next;        
    // }

    if (buffer->count > 0) {
        while (buffer->next != NULL && buffer->count > 0) {
            buffer = buffer->next;
        }

        if (buffer->count > 0) {
            buffer->next = (DebugDrawTextInstanceBuffer *)Plat.AllocateMem(sizeof(DebugDrawTextInstanceBuffer));
            InitDebugDrawTextInstanceBuffer(buffer->next);

            buffer = buffer->next;    
        }
    }

    buffer->model = TRS(position, rotation, V3(1));
            
    real32 x = 0.0f;
    for (int i = 0; i < length; i++) {
       
        uint32 bufferIndex = buffer->count;

        uint32 codepoint;
        GlyphInfo info;
        {
            //TIMED_BLOCK();
            codepoint = GetInternalCodepoint(font, textBuffer[i]);
            info = GetGlyphInfo(font, codepoint);
        }
        real32 advance = info.advance * size;

        {
            //TIMED_BLOCK();
            buffer->buffer[bufferIndex].codepoint = codepoint;
            buffer->buffer[bufferIndex].scale = V2(info.size.x, info.size.y) * size;
            buffer->buffer[bufferIndex].color = color;
            buffer->buffer[bufferIndex].rotation = rotation;
            
            if (!IsSpace(textBuffer[i])) {
                buffer->buffer[bufferIndex].position = V3(x + size * info.lowerLeft.x,
                                                          info.lowerLeft.y * size, 0.0f);
            }
            else {
                buffer->buffer[bufferIndex].position = V3(x, 0.0f, 0.0f);
            }
        
            if (cursorAt - 1 == i) {
                if (!cursorScreen) {
                    vec3 cursorBottom = buffer->buffer[bufferIndex].position;
                    cursorBottom.x += advance;
                    cursorBottom.y -= info.lowerLeft.y * size;
                    DebugDrawLine(cursorBottom, cursorBottom + V3(0.0f, lineHeight, 0.0f), GREEN);
                }
                else {
                    vec2 cursorBottom = V2(buffer->buffer[bufferIndex].position.x,
                                           buffer->buffer[bufferIndex].position.y);
                    cursorBottom.x += advance;
                    cursorBottom.y -= info.lowerLeft.y * size;
                    DebugDrawLineScreen(cursorBottom, cursorBottom + V2(0.0f, lineHeight), GREEN);
                }
            }

            x += advance;
        
            if (dimensions != NULL) {
                dimensions->x = x;
                dimensions->y = lineHeight;
            }

            buffer->count += 1;
        }
    }

    if (cursorAt == 0) {
        if (!cursorScreen) {
            vec3 cursorBottom = position;
            DebugDrawLine(cursorBottom, cursorBottom + V3(0.0f, lineHeight, 0.0f), GREEN);
        }
        else {
            vec2 cursorBottom = V2(position.x, position.y);
            DebugDrawLineScreen(cursorBottom, cursorBottom + V2(0.0f, lineHeight), GREEN);
        }
    }
}

void DebugDrawText(vec3 position, quaternion rotation, real32 size, vec4 color, int32 cursorAt, vec2 *dimensions, const char *format, ...) {
    va_list args;
    va_start(args, format);
    
    _DebugDrawText(DebugMem->debugDraw.textInstanceBufferHead, position, rotation, size, color, cursorAt, false, dimensions, format, args);

    va_end(args);
}

void DebugDrawText(vec3 position, quaternion rotation, real32 size, vec4 color, vec2 *dimensions, const char *format, ...) {
    va_list args;
    va_start(args, format);
    
    _DebugDrawText(DebugMem->debugDraw.textInstanceBufferHead, position, rotation, size, color, -1, false, dimensions, format, args);

    va_end(args);
}

void DebugDrawText(vec3 position, quaternion rotation, real32 size, vec4 color, int32 cursorAt, const char *format, ...) {
    va_list args;
    va_start(args, format);
    
    _DebugDrawText(DebugMem->debugDraw.textInstanceBufferHead, position, rotation, size, color, cursorAt, false, NULL, format, args);

    va_end(args);
}

void DebugDrawText(vec3 position, quaternion rotation, real32 size, vec4 color, const char *format, ...) {
    va_list args;
    va_start(args, format);
    
    _DebugDrawText(DebugMem->debugDraw.textInstanceBufferHead, position, rotation, size, color, -1, false, NULL, format, args);

    va_end(args);
}

void DebugDrawText(vec3 position, real32 size, vec4 color, const char *format, ...) {
    va_list args;
    va_start(args, format);
    
    _DebugDrawText(DebugMem->debugDraw.textInstanceBufferHead, position, IdentityQuaternion(), size, color, -1, false, NULL, format, args);

    va_end(args);
}

void DebugDrawVector(vec3 position, quaternion rotation, real32 size, vec4 color) {
    DebugDrawText(position, rotation, size, color, "(%.2f %.2f %.2f)", position.x, position.y, position.z);
}

void DebugDrawTextScreen(vec2 position, real32 size, vec4 color, int32 cursorAt, vec2 *dimensions, const char *format, ...) {
    va_list args;
    va_start(args, format);
    
    _DebugDrawText(DebugMem->debugDraw.screenTextInstanceBufferHead, V3(position, 0), IdentityQuaternion(), size, color, cursorAt, true, dimensions, format, args);

    va_end(args);
}

void DebugDrawTextScreen(vec2 position, real32 size, vec4 color, vec2 *dimensions, const char *format, ...) {
    va_list args;
    va_start(args, format);
    
    _DebugDrawText(DebugMem->debugDraw.screenTextInstanceBufferHead, V3(position, 0), IdentityQuaternion(), size, color, -1, true, dimensions, format, args);

    va_end(args);
}

void DebugDrawTextScreen(vec2 position, real32 size, vec4 color, const char *format, ...) {
    va_list args;
    va_start(args, format);
    
    _DebugDrawText(DebugMem->debugDraw.screenTextInstanceBufferHead, V3(position, 0), IdentityQuaternion(), size, color, -1, true, NULL, format, args);

    va_end(args);
}

void UpdateDebugRecords() {
    for(int i = 0; i < DEBUG_RECORD_COUNT; i++) {
        DebugRecord *record = &DebugMem->debugRecords[i];
        uint32 cycleCount = record->hitAndCycleCount;

        if (cycleCount > 0) {
            if (cycleCount > record->maxCycleCount) {
                record->maxCycleCount = cycleCount;
            }
            if (cycleCount < record->minCycleCount) {
                record->minCycleCount = cycleCount;
            }
            
            record->lastNonZeroCycleCount = cycleCount;
            record->lastNonZeroElapsedTime = record->timeElapsed;
        }
        
        uint64 hitAndCycleCount = EtcAtomicExchange64(&record->hitAndCycleCount, 0);

        real64 elapsedTime = EtcAtomicExchange64((uint64 *)&record->timeElapsed, (uint64)0);
    }
}

void DebugUpdate(EtcGameMemory *mem) {
    if (DebugMem->debugFont == NULL) {
        DebugMem->debugFont = GetFontTable(Game.assets, DebugMem->debugFontHandle);
    }

    // Debug Log
    if (InputActionPressed(&mem->inputActions, InputAction_LogToggle)) {
        switch (DebugMem->log.state) {
            case DebugLogState_Hidden: {
                DebugMem->log.state = DebugLogState_Visible;
            } break;

            case DebugLogState_Visible: {
                DebugMem->log.state = DebugLogState_Hidden;
            } break;
        }
    }

    // Render Mode Override
    if (InputActionPressed(&mem->inputActions, InputAction_RenderModeCycle, true)) {
        if (DebugMem->shouldOverrideRenderMode) {
            DebugMem->renderModeOverride = (RenderMode)((uint32)DebugMem->renderModeOverride + 1);
            if ((uint32)DebugMem->renderModeOverride >= ENUM_VALUECOUNT(RenderMode)) {
                DebugMem->shouldOverrideRenderMode = false;
            }
        }
        else {
            DebugMem->shouldOverrideRenderMode = true;
            DebugMem->renderModeOverride = (RenderMode)0;
        }
    }


    SceneHandle currentSceneHandle = SceneHandleInvalid();
    if (Game.sceneManager->active.sceneCount > 0) {
        currentSceneHandle = GetRootScene(Game.sceneManager->active.scenes[0]);
    }

    DebugMem->colorPickerWindowData.renderedThisFrame = false;
    DebugMem->contextMenuData.renderedThisFrame = false;
}
    
void DebugRender(EtcGameMemory *mem) {
    RenderDebugDraw();
}

