
#ifndef _ETC_UTF8_H
#define _ETC_UTF8_H

#include "etc_types.h"

uint32 utf8_bytelength(uint32 codepoint);

uint32 utf8_next(uint8 *src, uint32 *byteOffset);

// - srcSize is size of src in bytes
// - destCount is number of wide characters in dest
// - Stops at null-terminals in src, but does not guarantee that dest is null-terminated!
// - Returns number of characters converted
uint32 utf8_toucs(uint8 *src, uint32 srcSize, uint32 *dest, uint32 destCount);

// - srcCount is number of wide characers in src
// - destSize is size of dest in bytes
// - Stops at null-terminals in src, but does not guarantee that dest is
// null-terminated! But dest will be null-terminated if there is enough
// space.
// - Returns number of bytes converted
uint32 ucs_toutf8(uint32 *src, uint32 srcCount, uint8 *dest, uint32 destSize);

uint32 ucs16_toutf8(uint16 *src, uint32 srcCount, uint8 *dest, uint32 destSize);

#endif
