
#ifndef _ETC_METAPROGRAMMING_H
#define _ETC_METAPROGRAMMING_H

#define STRUCT(...)

#define FIELD(...)

#define ENUM(...)
#define BITFIELD(...)
#define BITARRAY(...)

#define ENUM_STRINGVALUE(enumType, enumValue) (enumType##_StringValues[(uint32)(enumValue)])
#define ENUM_STRINGTABLE(enumType) (enumType##_StringValues)
#define ENUM_VALUECOUNT(enumType) ARRAY_LENGTH(const char *, ENUM_STRINGTABLE(enumType))

#define ENUM_STRINGVALUESHORT(enumType, enumValue) (enumType##_StringValues[(uint32)(enumValue)] + StringLength(#enumType))

#define ENUM_FINDVALUE(enumType, nameString, result) FindString(&ENUM_STRINGTABLE(enumType), ENUM_VALUECOUNT(enumType), (nameString), (uint32 *)(result))

#define ENUM_FINDVALUELENGTH(enumType, nameString, nameStringLength, result) FindString(&ENUM_STRINGTABLE(enumType), ENUM_VALUECOUNT(enumType), (nameString), (nameStringLength), (uint32 *)(result))


#define DEFINE_FUNCTIONTYPE(functionType, returnType, ...)
#define FUNCTION(functionType, ...)

enum PersistentFuncType : uint32;

struct FuncHandle {
    PersistentFuncType funcType;
    uint32 tableIndex;
};


#define ASSET(...)


#define TAGGED_UNION(name, ...)                 \
    struct name {                               \
        name##_TypeTag type;                    \
        uint8 _padding[4];                      \
        union __VA_ARGS__ _data;                \
    }

#define TAGGEDUNION_TYPECOUNT(taggedUnionType) ENUM_VALUECOUNT(taggedUnionType##_TypeTag)

struct TaggedUnion_Untyped {
    uint32 type;

    // Ensure 8-byte alignment for _data field
    uint8 _padding[4];

    union {} _data;
};

inline b32 _TaggedUnionGetTypeValue(TaggedUnion_Untyped *taggedUnion, uint32 type, void *data, uint32 dataSize) {

    // @TODO: we can look up the dataSize in a pregenerated table and
    // assume there's enough space in the data pointer!
    
    if (taggedUnion->type == type) {
        Plat.CopyMem(data, &taggedUnion->_data, dataSize);
        return true;
    }

    return false;
}

#define TaggedUnionGetValue(unionType, unionPtr, fieldName, dataPtr, size) _TaggedUnionGetTypeValue((TaggedUnion_Untyped *)unionPtr, (uint32)(unionType##_##fieldName), dataPtr, size)
#define TaggedUnionSetValue(unionType, unionPtr, fieldName, value)      \
    {                                                                   \
        ((unionType *)unionPtr)->type = unionType##_##fieldName;        \
        ((unionType *)unionPtr)->_data.fieldName = value;               \
    }

#define TaggedUnionDataPointer(unionPtr) (void *)((uint8 *)(unionPtr) + FIELD_OFFSET(TaggedUnion_Untyped, _data))


#define SCENE(name, ...)
#define COMPONENT(name, ...) struct name##Component
#define SYSTEM(name, ...) struct name##System : EtcSystem

#endif

